﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using DirectService.Tools;
using JLHHJSvr.BLL;
using JLHHJSvr.Com;
using JLHHJSvr.Com.Model;
using JLHHJSvr.LJException;
using JLHHJSvr.LJFramework.Tools;
using JLHHJSvr.Tools;
using LJLib.DAL.SQL;
using LJLib.Net.SPI.Server;

namespace JLHHJSvr.Excutor
{
    internal sealed class GetERPMtrlTypeListExcutor : ExcutorBase<GetERPMtrlTypeListRequest, GetERPMtrlTypeListResponse>
    {
        protected override void ExcuteInternal(GetERPMtrlTypeListRequest request, object state, GetERPMtrlTypeListResponse rslt)
        {
            var tokendata = BllHelper.GetToken(request.token);
            if (tokendata == null)
            {
                rslt.ErrMsg = "会话已经中断，请重新登录";
                return;
            }

            using (var con = new SqlConnection(GlobalVar.ConnectionString))
            using (var cmd = con.CreateCommand())
            {
                con.Open();

                using (var erp_con = new SqlConnection(BllHelper.GetERPConnectString(cmd)))
                using (var erp_cmd = erp_con.CreateCommand())
                {
                    erp_con.Open();

                    var cusion = new menuRecursion();

                    //var erpHelper = HelperBase.GetHelper<ERPHelper>(null);

                    //var list = erpHelper.GetERPList<u_mtrltype>("GetL1Mtrltype", null);

                    //var pk = new PkName()
                    //{
                    //    MainField = "mtrltypeid",
                    //    MainName = "mtrltype",
                    //    ParentField = "parentid"
                    //};

                    //ListEx.GetRecursions(list, pk, out var resultList);

                    //rslt.reList = resultList;


                    string MainField = "mtrltypeid";
                    string MainName = "mtrltype";
                    string ParentField = "parentid";

                    //查看有权限类别的物料
                    //var mtrltypeids = UserHelper.ParsePowerStr(cmd, tokendata.empid, "mtrltypestr");

                    var selectStr = @"
                    SELECT
                        u_mtrltype.mtrltypeid,
                        u_mtrltype.mtrltype,
                        u_mtrltype.handtype,
                        u_mtrltype.sonflag,
                        u_mtrltype.parentid,
                        u_mtrltype.mtrlprp,
                        u_mtrltype.typecode,
                        u_mtrltype.typecodestr
                    FROM u_mtrltype";
                    var outputFields = "mtrltypeid,mtrltype,handtype,sonflag,parentid,mtrlprp,typecode,typecodestr";

                    var whereList = new List<string>();
                    if (request.parentid != null)
                    {
                        whereList.Add("u_mtrltype.parentid = " + request.parentid.ToString());
                    }
                    //if (!string.IsNullOrEmpty(mtrltypeids))
                    //{
                    //    whereList.Add($"u_mtrldef.mtrltypeid IN {mtrltypeids}");
                    //}

                    List<u_mtrltype> DataList = new List<u_mtrltype>();
                    DbSqlHelper.SelectJoin(erp_cmd, selectStr, ListEx.GetWhereStr(whereList), null, null, outputFields, 0, 0, DataList);


                    if (request.RecurionType == 1)
                    {
                        // 转换成层级结构

                        var allList = DataList;
                        var List0 = allList.Where(t => t.parentid == 0).ToList();
                        rslt.RecurionList = new List<Recursion2>();
                        var RecurionList = new List<Recursion2>();

                        foreach (var mx in List0)
                        {
                            var curion = new Recursion2() { text = mx.mtrltype, value = mx.mtrltypeid.Value };
                            RecurionList.Add(curion);
                        }

                        var pk = new PkName()
                        {
                            MainField = MainField,
                            MainName = MainName,
                            ParentField = ParentField
                        };
                        var idList = new List<int>();
                        idList.Add(0);
                        cusion.GetRecursions(DataList, pk, RecurionList, idList);
                        rslt.RecurionList = RecurionList;
                    }
                    else
                    {
                        // 完成列出数据
                        rslt.DataList = new List<u_mtrltype>();
                        rslt.DataList = DataList;
                    }
                }
            }
        }
    }
}
